--- src/skethtool.c	2012-01-26 17:46:09.000000000 +0200
+++ src/skethtool.c	2012-09-23 00:01:27.539783621 +0300
@@ -991,40 +991,6 @@
 
 /*****************************************************************************
  *
- *	SkGeSetSG - set the SG parameters
- *
- * Description:
- *	This function sets the SG parameters
- *
- * Returns:
- *	==0:	everything fine, no error
- *	!=0:	the return value is the error code of the failure
- */
-int SkGeSetSG(struct net_device *dev,
-			u32 data)
-{
-	return ethtool_op_set_sg(dev, data);
-}
-
-/*****************************************************************************
- *
- *	SkGeSetTxCsum - set the TxCsum parameters
- *
- * Description:
- *	This function sets the TxCsum parameters
- *
- * Returns:
- *	==0:	everything fine, no error
- *	!=0:	the return value is the error code of the failure
- */
-int SkGeSetTxCsum(struct net_device *dev,
-			u32 data)
-{
-	return ethtool_op_set_tx_csum(dev, data);
-}
-
-/*****************************************************************************
- *
  *	SkGeSetRxCsum - set the SkGeSetRxCsum parameters
  *
  * Description:
--- src/skge.c	2012-01-26 17:46:09.000000000 +0200
+++ src/skge.c	2012-09-23 00:01:57.830477035 +0300
@@ -263,8 +263,6 @@
 extern int SkGeSetWolSettings(struct net_device *dev, struct ethtool_wolinfo *ewol);
 extern int SkGeSetPauseParam(struct net_device *dev, struct ethtool_pauseparam *ecmd);
 extern int SkGeSetCoalesce(struct net_device *dev, struct ethtool_coalesce *ecmd);
-extern int SkGeSetSG(struct net_device *dev, u32 data);
-extern int SkGeSetTxCsum(struct net_device *dev, u32 data);
 extern int SkGeSetRxCsum(struct net_device *dev, u32 data);
 extern int SkGePhysId(struct net_device *dev, u32 data);
 
@@ -312,16 +310,13 @@
 #endif
 
 static struct ethtool_ops sk98lin_ethtool_ops = {
-	.get_sg			= ethtool_op_get_sg,
 	.get_link		= ethtool_op_get_link,
-	.get_tx_csum		= ethtool_op_get_tx_csum,
 /*	.get_perm_addr		= ethtool_op_get_perm_addr, */
 	.get_settings		= SkGeGetSettings,
 	.get_drvinfo		= SkGeGetDrvInfo,
 	.get_wol		= SkGeGetWolSettings,
 	.get_pauseparam		= SkGeGetPauseParam,
 	.get_coalesce		= SkGeGetCoalesce,
-	.get_rx_csum		= SkGeGetRxCsum,
 	.get_strings		= SkGeGetStrings,
 #if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,33)
 	.get_stats_count	= SkGeGetStatsLen,
@@ -336,19 +331,12 @@
 	.set_wol		= SkGeSetWolSettings,
 	.set_pauseparam		= SkGeSetPauseParam,
 	.set_coalesce		= SkGeSetCoalesce,
-	.set_sg			= SkGeSetSG,
-	.set_tx_csum		= SkGeSetTxCsum,
-	.set_rx_csum		= SkGeSetRxCsum,
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
 	.phys_id		= SkGePhysId,
 #else
 	.set_phys_id		= SkGePhysId,
 #endif
 
-#ifdef NETIF_F_TSO
-	.get_tso		= ethtool_op_get_tso,
-	.set_tso		= SkGeSetTSO,
-#endif
 
 	.get_eeprom_len		= SkGeGetEepromLen,
 	.get_eeprom		= SkGeGetEeprom,